<?php
define('DEBUG',0);
if(!empty($_SERVER['DOCUMENT_ROOT']))
{
	$path = rtrim ($_SERVER['DOCUMENT_ROOT'],'/');
}
else
{
	$path = '/usr/local/esia/public_html/';
	$_SERVER['DOCUMENT_ROOT'] = $path;
}
include $path.'/esia.conf.php';
//include_once $path.'/data/libs/CiscoSwitch.class.php';
/*
 * 
 * -- Table: public.esia_switch_scan

-- DROP TABLE IF EXISTS public.esia_switch_scan;

CREATE TABLE IF NOT EXISTS public.esia_switch_scan
(
    switch_scan_id bigint NOT NULL,
    switch_scan_time timestamp without time zone,
    switch_scan_state character varying(10) COLLATE pg_catalog."default",
    CONSTRAINT esia_switch_scan_pkey PRIMARY KEY (switch_scan_id),
    CONSTRAINT switch_scan_foreign_key FOREIGN KEY (switch_scan_id)
        REFERENCES public.esia_device (device_id) MATCH SIMPLE
        ON UPDATE NO ACTION
        ON DELETE NO ACTION
)
WITH (
    OIDS = FALSE
)
TABLESPACE pg_default;

ALTER TABLE IF EXISTS public.esia_switch_scan OWNER to esia;
 * 
 * 
 */

//connection à la base de donnée
try
{
	$dbconnection = new PDO('pgsql:host='.DB_HOST.';port='.DB_PORT.';dbname='.DB_NAME, DB_USERNAME, DB_PWD);
	$dbconnection->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_WARNING);
}
catch(Exception $e)
{
	echo 'PDO SQL ERROR: '.$e->getMessage().'<br />';
	echo 'N° : '.$e->getCode();
}

include_once MVCMODEL;
include_once $path."/plugin/cloudswitch/model_switch.php";
include_once $path."/plugin/cloudswitch/libs/USL.class.php";
include_once $path."/plugin/cloudswitch/libs/cron.lib.php";
include_once $path."/data/libs/CiscoSwitch.class.php";

$scans = Model_switch::getScanState($dbconnection,null,'START');
$nodes=array();
foreach ($scans as $scan)
{
    $nodes[] = Model_switch::InstanceNode($dbconnection,$scan['nodeid']);
}
$querySelectInter = $dbconnection->prepare("SELECT interface_id FROM esia_interface WHERE interface_mac_addr = ?");
$querySelectInterWithInterfaceName = $dbconnection->prepare("SELECT interface_mac_addr FROM esia_interface WHERE interface_name = ? AND interface_device_id=?");
$querySelectInterSwitch = $dbconnection->prepare("SELECT interface_id FROM esia_interface WHERE interface_device_id = ?  AND interface_ifindex =?");
$queryDeleteConnected = $dbconnection->prepare("DELETE FROM esia_interface_connected_to WHERE conint_switch_interface_id = ?;");
$queryInsertConnected = $dbconnection->prepare("INSERT INTO esia_interface_connected_to(conint_switch_interface_id, conint_interface_id2,conint_protocol)VALUES (?, ?,?);");


$queryDeleteMACConnected = $dbconnection->prepare("DELETE FROM esia_interface_node_connected WHERE connected_interface_id IN (SELECT interface_id FROM esia_interface WHERE interface_device_id = ?);");

$queryInsertmacConnected = $dbconnection->prepare("INSERT INTO esia_interface_node_connected(connected_id,connected_description, connected_mac, connected_protocol, connected_interface_id)
                                                    VALUES (DEFAULT, ?, ?, ?, ?);");

echo "MAC-ADRESS: START\n";
//Liaison via les adresse mac des liens non trunk. 
foreach ($nodes as $key => $node)
{   
        try
        {
            Model_switch::UpdateScanState($dbconnection,$node->getId(),'STARTED');
            echo "MAC-ADRESS: START ".$node->getName()."\n";
            Model_esia::executeStatement($queryDeleteMACConnected,array($node->getId()));
		    Trace($node->getId().' '.$node->getName().' MAC ADDRESS TABLE: ');
		    $objectid = $node->getSysObjectId();
            print_r($objectid);
		    //si c'est un switch cisco
		    if(preg_match('#'.$objectid[0].'#','\.3\.6\.1\.4\.1\.9'))
		    {
			    getCiscoMacAdresseTable($node,$querySelectInter,$queryDeleteConnected,$querySelectInterSwitch,$queryInsertConnected,$queryInsertmacConnected);
		    }
            elseif(preg_match('#'.$objectid[0].'#','\.3\.6\.1\.4\.1\.4413'))
		    {
			    getUbiquityMacAdresseTable($node,$querySelectInter,$queryDeleteConnected,$querySelectInterSwitch,$queryInsertConnected,$queryInsertmacConnected);
		    }
		    else
		    {
			    getMacAdresseTable($node,$querySelectInter,$queryDeleteConnected,$querySelectInterSwitch,$queryInsertConnected,$queryInsertmacConnected);
		    }
		    //getCiscoMacAdresseTable($node,$querySelectInter,$queryDeleteConnected,$querySelectInterSwitch,$queryInsertConnected)
            Model_switch::UpdateScanState($dbconnection,$node->getId(),'END');
        }
        catch(Exception $e)
        {
            Model_switch::UpdateScanState($dbconnection,$node->getId(),'FAILED');
            unset($nodes[$key]);
            echo "MAC-ADRESS: FAILED :".$node->getName().":".$e->getMessage()."\n";
        }
}
echo "MAC-ADRESS: END\n";
echo " LIAISON VIA LLDP\n";
//
//on interroge via LLDP
//
foreach ($nodes as $node)
{
	try
	{
		//récupération de la correspondace LLDPID ==> IfIndex
		$portifIndex = array();
		$snmp = $node->getSNMPObject();
		$lldpId =  array();
		//Si switch est bien compatible LLDP-MIB il ne générera pas d'exception
		$result = $snmp->snmpwalkoid($node->getIPv4Adress(), '1.0.8802.1.1.2.1.3.7.1.4');
		foreach($result as $key => $value)
		{
			$ifDesc = formatString($value);
			if(preg_match('#0\.8802\.1\.1\.2\.1\.3\.7\.1\.4\.([0-9\.]*)#',$key,$regs ))
			{
				$lldpId[$ifDesc]= $regs[1];
			}
		}
		$list_LLDPID_Ifindex =array();
		//on a les LLDP ID maintenant on va récupérer le ifIndex
		$result = $snmp->snmpwalkoid($node->getIPv4Adress(), '1.3.6.1.2.1.2.2.1.2');
		foreach($result as $key => $value)
		{
			$ifDesc = formatString($value);
			if(preg_match('#3\.6\.1\.2\.1\.2\.2\.1\.2\.([0-9\.]*)#',$key,$regs ))
			{
				if(array_key_exists($ifDesc, $lldpId))
				{
					//création du tableau de correspondance ifindex vs lldpid
					$list_LLDPID_Ifindex[$lldpId[$ifDesc]]= $regs[1];
				}
			}
		}
		// Si le $list_LLDPID_Ifindex est égal à 0  c'est que le switch ne respecte pas le standart grrr ><
		//on va donc interrogé le lldpLocPortId 	1.0.8802.1.1.2.1.3.7.1.3 afin de savoir si on peut faire une correspondance:
		if(count($list_LLDPID_Ifindex)==0)
		{
			//Si switch est bien compatible LLDP-MIB il ne générera pas d'exception
			$result = $snmp->snmpwalkoid($node->getIPv4Adress(), '1.0.8802.1.1.2.1.3.7.1.3');
			foreach($result as $key => $value)
			{
				$ifDesc = formatString($value);
				if(preg_match('#0\.8802\.1\.1\.2\.1\.3\.7\.1\.3\.([0-9\.]*)#',$key,$regs ))
				{
					$lldpId[$ifDesc]= $regs[1];
			
				}
			}
			$list_LLDPID_Ifindex =array();
			//on a les LLDP ID maintenant on va récupérer le ifIndex
			$result = $snmp->snmpwalkoid($node->getIPv4Adress(), '1.3.6.1.2.1.2.2.1.2');
			foreach($result as $key => $value)
			{
				$ifDesc = formatString($value);
				if(preg_match('#3\.6\.1\.2\.1\.2\.2\.1\.2\.([0-9\.]*)#',$key,$regs ))
				{
					if(array_key_exists($ifDesc, $lldpId))
					{
						//création du tableau de correspondance ifindex vs lldpid
						$list_LLDPID_Ifindex[$lldpId[$ifDesc]]= $regs[1];
					}
				}
			}
		}
		
		//TABLEAU DE CORRESPONDANCE OK
		Trace("\t LLDP:".$node->getId().' '.$node->getName().' TABLEAU DE CORRESPONDANCE OK' );
		Trace($list_LLDPID_Ifindex);
		
		try
		{
			//on récucpère la liste des mac adresse connectée 
			$listmac = getLLDPMacAddressBySNMP($node);
			Trace($listmac);
			foreach($listmac as $lineMac)
			{
				$counter = $lineMac['counter'];
				$lldpid = $lineMac['lldpid'];
				$neighborid =$lineMac['neighborid'];
				$mac = $lineMac['mac'];
				Trace("\t\tLLDP: ".$mac.":".$list_LLDPID_Ifindex[$lldpid].":LLDPID:$lldpid:$counter:$neighborid");
				$state = linkInterface($mac, $list_LLDPID_Ifindex[$lldpid], $node,'LLDP', $querySelectInter, $queryDeleteConnected, $querySelectInterSwitch, $queryInsertConnected);
				//si state == -1 alors la mac n'a pas été trouvée dans la DB (noeud inexistant) ou alors il s'agit de la mac interne d'un switch et non pas de la mac de l'interface
				if($state==-1)
				{
					//on va tenter de récupérer le nom de l'appareil et l'interface et de quand même essayer de les liée
					$value = $node->snmpget("1.0.8802.1.1.2.1.4.1.1.9.$counter.$lldpid.$neighborid");
					$value = formatString($value);
					//si le nom n'est pas vide on va tenter d'instancier un noeud
					if(!empty($value))
					{
						try
						{
							$distnode = Model_esia::InstanceNode($dbconnection, $value);
							Trace("\tLLDP: ".$distnode->getName().' Instance SUCCESS');
							//Ona le noeud maintenant on récupère l'interface
							$value = $node->snmpget("1.0.8802.1.1.2.1.4.1.1.8.$counter.$lldpid.$neighborid");
							$value = formatString($value);
							Trace($value);
							$result = Model_esia::executeStatement($querySelectInterWithInterfaceName,array($value,$distnode->getId()));
							$result = $result->fetchAll();
							Trace($result);
							//si c'est différents de 0 c'est que l'interface a été trouvée est dans la base de données.
							if(count($result)!=0)
							{
								Trace("\tLLDP: ".$distnode->getName().' '.$result[0]['interface_mac_addr'].' '.$list_LLDPID_Ifindex[$lldpid].' '.$distnode->getName());
								$state = linkInterface($result[0]['interface_mac_addr'], $list_LLDPID_Ifindex[$lldpid], $node,'LLDP', $querySelectInter, $queryDeleteConnected, $querySelectInterSwitch, $queryInsertConnected);
							}
						}
						catch(Exception $e )
						{
							Trace("\tLLDP: $value : NODE NO FOUND");
						}
					}
				}
			}
		}
		catch(Exception $e )
		{
			Trace("\tLLDP: ".$node->getName()." LLDPID:$lldpid:".$e->getMessage());
		}
	}
	catch(Exception $e)
	{
		Trace("\tLLDP:".$node->getId().' '.$node->getName().' SNMP ERROR: '.$e->getMessage());
	}   
}
echo " LIAISON VIA CDP\n";
//
//on interroge via CDP
//

$querySelectSwitchByIP = $dbconnection->prepare("SELECT device_id,interface_id 
												 FROM esia_device 
												 JOIN esia_interface ON interface_device_id = device_id 
												 WHERE device_ip_addr = ? AND interface_name=?");
foreach ($nodes as $node)
{
	try
	{
		$result = $node->snmpwalkoid("1.3.6.1.4.1.9.9.23.1.2.1.1.20");
		foreach($result as $key => $value)
		{
			if(preg_match('#\.3\.6\.1\.4\.1\.9\.9\.23\.1\.2\.1\.1\.20\.([0-9\.]*)\.([0-9]*)#',$key,$regs ))
			{
				$value = formatHexString($value);
				$ip = hexdec($value);
				$cdpid = $regs[2];
				//on va rechercher le nom de l'interface distante:
				$ifName = $node->snmpget("1.3.6.1.4.1.9.9.23.1.2.1.1.7.$regs[1].$cdpid");
				$ifname = formatString($ifName);
				//on sélectionne le switch distant
				$swdistant = Model_esia::executeStatement($querySelectSwitchByIP,array($ip,$ifname));
				$swdistant = $swdistant->fetchAll();
				//si c'est différents de 0 c'est que le switch distant est référencé
				if(count($swdistant)!=0)
				{
					//on prend l'id de l'interface locale:
					$ridlocal = Model_esia::executeStatement($querySelectInterSwitch,array($node->getId(),$regs[1]));
					$ridlocal = $ridlocal->fetchAll();
					$idlocal = $ridlocal[0]['interface_id'];
					Model_esia::executeStatement($queryDeleteConnected,array($idlocal));
					Model_esia::executeStatement($queryInsertConnected,array($swdistant[0]['interface_id'],$idlocal,'CDP'));

				}


			}
		}
	
	}
	catch(Exception $e)
	{
		Trace("\tCDP:".$node->getId().' '.$node->getName().' SNMP ERROR: '.$e->getMessage());
	}
}
/**
 * Lie les mac addresse d'un noeud à une interface donnée
 * @param: $dbconnection l'objet de connexion PDO
 * @param: $ifindex ifindex de l'interface ou est connectée la mac
 * @param: $node Un object device représentant le switch
 * @param: $type Type de protocol utilisé
 * @param: $querySelectInter requete préparée qui récupère l'id de l'interface lié à la mac address
 * @param: $queryDeleteConnected requete préparée qui supprime l'ancienne liaison
 * @param: $querySelectInterSwitch requete préparée qui permet de récupéré l'id de l'interface via le node Id et le ifindex
 * @param: $queryInsertConnected requete préparée qui de lié les 2 autre interface
 * @return: /
 * @exception: esiaDBException si une erreur survient
 */
function linkInterface($mac,$ifindex,$node,$type,$querySelectInter,$queryDeleteConnected,$querySelectInterSwitch,$queryInsertConnected,$queryInsertmacConnected= null )
{
    $int_swId=null;
    if(!empty($queryInsertmacConnected))
    {
        // insertion tableau par défaut 
	    $result = Model_esia::executeStatement($querySelectInterSwitch,array($node->getId(),$ifindex));
	    $result = $result->fetchAll();
	    $int_swId = $result[0];
        $result = Model_esia::executeStatement($queryInsertmacConnected,array('',$mac,'MACTABLE',$int_swId['interface_id']));
    }

	$status = 1;
	//On récupère les identifiants des interface liée à cette mac addresse
	$result = Model_esia::executeStatement($querySelectInter,array($mac));
	$result = $result->fetchAll();
	//si c'est différents de 0 c'est que l'appareil est dans la base de données.
	if(count($result)!=0)
	{
        $int = $result[0];
        if(empty($int_swId))
        {
	        $result = Model_esia::executeStatement($querySelectInterSwitch,array($node->getId(),$ifindex));
	        $result = $result->fetchAll();
	        $int_swId = $result[0];
        }
		Model_esia::executeStatement($queryDeleteConnected,array($int_swId['interface_id']));
		//on insert toutes les données.
		Model_esia::executeStatement($queryInsertConnected,array($int_swId['interface_id'],$int['interface_id'],$type));		
	}
	else
	{
		$status = -1;
	}
	return $status;
}
/**
 * @brief parse la table de mac adresse en SNMP 
 * @param Device $node objet node
 * @param PDOStatement $querySelectInter request pdo de selection d'interface
 * @param PDOStatement $queryDeleteConnected request pdo qui élimine les liaison entre les interface
 * @param PDOStatement $querySelectInterSwitch selectetionne l'interface des switch 
 * @param PDOStatement $queryInsertConnected lie les interfaces des device avec les switchs
 */
function getCiscoMacAdresseTable($node,$querySelectInter,$queryDeleteConnected,$querySelectInterSwitch,$queryInsertConnected)
{
	try 
	{
		Trace($node->getId().' '.$node->getName().' MAC ADDRESS TABLE: ');
		//on instancie des switchs cisco.
		$sw = new CiscoSwitch($node);
		//$sw = new Switchs();
		//$sw->constructDevice($node);
		//on récupère la vlan database pour récupérer les dot1 port qui ne sont accessible que via la communauté snmp +@<vlanid>
		$vlandatabase = $sw->getVlanDataBase();
		Trace($node->getId().' '.$node->getName().' MAC ADDRESS TABLE: VLAN DATABASE SUCCESS');
		
		//récupération de la correspondace dot1port ==> IfIndex
		$portifIndex = array();
		$snmp = $sw->getSNMPObject();
		$com = $snmp->getCommunity();
		foreach($vlandatabase as $vlanid)
		{
			try
			{
				$comu = $com.'@'.$vlanid;
				$snmp->setCommunity($comu);
				$result = $snmp->snmpwalkoid($sw->getIPv4Adress(), '1.3.6.1.2.1.17.1.4.1.2');
				foreach($result as $key => $line)
				{
					$line = formatInteger($line);
					if(preg_match('#\.3\.6\.1\.2\.1\.17\.1\.4\.1\.2\.([0-9\.]*)#',$key,$regs ))
					{
						$portifIndex[$line]= $regs[1];
					}
				}
			}
			catch(Exception $e)
			{
				Trace("\t".$node->getId().' '.$node->getName().' dot1port ==> IfIndex: ERROR: '.$e->getMessage());
			}
		}
		//récupération des interfaces et des ifindex
		$inters = $sw->getInterfacesMib();
		$arrInterface = array();
		foreach($inters as $int)
		{
			$mode = $int->getModeBySNMP();
			//si l'interfance n'est pas en trunk on la met dans le tableau de correspondance dot1port = > ifindex
			if($mode != 'trunk' )
			{
				if(array_key_exists($int->ifIndex, $portifIndex))
				{
					$arrInterface[$portifIndex[$int->ifIndex]] =$int->ifIndex;
				}
			}
		}
		Trace($node->getId().' '.$node->getName().' List interface no trunk with dot1Port');
		Trace($arrInterface);
		
		//on a toutes les interface qui ne sont pas en mode 'trunk' on va récupérer les mac adresse
		$com = $snmp->getCommunity();
		//on va récupérer toute les mac-addresse
		$dot1port=array();
		foreach($vlandatabase as $vlanid)
		{
			try
			{
				$comu = $com.'@'.$vlanid;
				$snmp->setCommunity($comu);
				//récupération du dot1dTpFdbPort (nécessaire pour récupéer les adresse mac par dot1port
				$dot1port = getdot1dTpFdbPort($snmp,$sw);
			}
			catch(Exception $e)
			{
				Trace("\t".$node->getId().' '.$node->getName()." mac-addresse FINAL ERROR: $vlanid :".$e->getMessage());
			}
		}
		Trace($node->getId().' '.$node->getName().' MAC ADDRESSE TABLE: ifindex => liste mac');
		Trace($dot1port);
		Trace($node->getId().' '.$node->getName().' MAC ADDRESSE TABLE: ifindex => liste mac');
		Trace($dot1port);
		foreach($dot1port as $ifindex => $macs)
		{
			if(count($macs)<5)
			{
				foreach($macs as $mac)
				{
					try
					{
						//on va lié les interface entre elle
						linkInterface($mac,$ifindex,$node,'MACTABLE',$querySelectInter,$queryDeleteConnected,$querySelectInterSwitch,$queryInsertConnected,$queryInsertmacConnected  );
					}
					catch(Exception $e)
					{
						Trace($node->getId().' '.$node->getName().' ERROR INSERT: '.$e->getMessage());
					}	
				}
			}
		}
	}
	catch(Exception $e)
	{
		Trace($node->getId().' '.$node->getName().' SNMP ERROR: '.$e->getMessage());
	}	
}
/**
 * @brief parse la table de mac adresse en SNMP
 * @param Device $node objet node
 * @param PDOStatement $querySelectInter request pdo de selection d'interface
 * @param PDOStatement $queryDeleteConnected request pdo qui élimine les liaison entre les interface
 * @param PDOStatement $querySelectInterSwitch selectetionne l'interface des switch
 * @param PDOStatement $queryInsertConnected lie les interfaces des device avec les switchs
 */
function getMacAdresseTable($node,$querySelectInter,$queryDeleteConnected,$querySelectInterSwitch,$queryInsertConnected,$queryInsertmacConnected)
{
	try
	{
		Trace($node->getId().' '.$node->getName().' MAC ADDRESS TABLE: ');
		//on instancie des switchs cisco.
		$sw = new Switchs($node);
		//$sw->constructDevice($node);
		//récupération de la correspondace dot1port ==> IfIndex
		$portifIndex = array();
		$snmp = $sw->getSNMPObject();
		$com = $snmp->getCommunity();
		try
		{
			$result = $snmp->snmpwalkoid($sw->getIPv4Adress(), '1.3.6.1.2.1.17.1.4.1.2');
			foreach($result as $key => $line)
			{
				$line = formatInteger($line);
				if(preg_match('#\.3\.6\.1\.2\.1\.17\.1\.4\.1\.2\.([0-9\.]*)#',$key,$regs ))
				{
					$portifIndex[$line]= $regs[1];
				}
			}
		}
		catch(Exception $e)
		{
			Trace("\t".$node->getId().' '.$node->getName().' dot1port ==> IfIndex: ERROR: '.$e->getMessage());
		}
		//récupération des interfaces et des ifindex
		$inters = $sw->getInterfacesMib();
		$arrInterface = array();
		foreach($inters as $int)
		{
			if(array_key_exists($int->ifIndex, $portifIndex))
			{
				$arrInterface[$portifIndex[$int->ifIndex]] =$int->ifIndex;
			}
		}
		Trace($node->getId().' '.$node->getName().' List interface no trunk with dot1Port');
		Trace($arrInterface);

		//on a toutes les interface qui ne sont pas en mode 'trunk' on va récupérer les mac adresse
		$com = $snmp->getCommunity();
		//on va récupérer toute les mac-addresse
		$dot1port=array();
		try
		{
			//récupération du dot1dTpFdbPort (nécessaire pour récupéer les adresse mac par dot1port
			$dot1port = getdot1dTpFdbPort($snmp,$sw);
		}
		catch(Exception $e)
		{
			Trace("\t".$node->getId().' '.$node->getName()." mac-addresse FINAL ERROR :".$e->getMessage());
		}
		Trace($node->getId().' '.$node->getName().' MAC ADDRESSE TABLE: ifindex => liste mac');
		Trace($dot1port);
		foreach($dot1port as $ifindex => $macs)
		{
			if(count($macs)<5)
			{
				foreach($macs as $mac)
				{
					try
					{
						//on va lié les interface entre elle
						linkInterface($mac,$ifindex,$node,'MACTABLE',$querySelectInter,$queryDeleteConnected,$querySelectInterSwitch,$queryInsertConnected,$queryInsertmacConnected  );
					}
					catch(Exception $e)
					{
						Trace($node->getId().' '.$node->getName().' ERROR INSERT: '.$e->getMessage());
					}	
				}
			}
		}
	}
	catch(Exception $e)
	{
		Trace($node->getId().' '.$node->getName().' SNMP ERROR: '.$e->getMessage());
	}
}
function getUbiquityMacAdresseTable($node,$querySelectInter,$queryDeleteConnected,$querySelectInterSwitch,$queryInsertConnected,$queryInsertmacConnected)
{
	try
	{
		Trace($node->getId().' '.$node->getName().' MAC ADDRESS TABLE: ');
		//on instancie des switchs cisco.
		$sw = new Switchs();
		$sw->constructDevice($node);
		//récupération de la correspondace dot1port ==> IfIndex
		$portifIndex = array();
		$snmp = $sw->getSNMPObject();
		$com = $snmp->getCommunity();
		try
		{
			$result = $snmp->snmpwalkoid($sw->getIPv4Adress(), '1.3.6.1.2.1.17.7.1.2.2.1.2');
            $mactable=array();
			foreach($result as $key => $line)
			{
				$ifindex = formatInteger($line);
				if(preg_match('#\.3\.6\.1\.2\.1\.17\.7\.1\.2\.2\.1\.2\.([0-9]*)\.([0-9\.]*)#',$key,$regs ))
				{
                    $arr = explode('.',$regs[2]);
                    $mac='';
                    foreach($arr as $t)
                    {
                        $mac.= dechex($t).':';
                    }
                    $mac = rtrim($mac,':');
                    $mactable[$ifindex][]=$mac;
				}
			}
            Trace($mactable);
		    foreach($mactable as $ifindex => $macs)
		    {
			    if(count($macs)<5)
			    {
				    foreach($macs as $mac)
				    {
					    try
					    {
						    //on va lié les interface entre elle
						    linkInterface($mac,$ifindex,$node,'MACTABLE',$querySelectInter,$queryDeleteConnected,$querySelectInterSwitch,$queryInsertConnected,$queryInsertmacConnected  );
					    }
					    catch(Exception $e)
					    {
						    Trace($node->getId().' '.$node->getName().' ERROR INSERT: '.$e->getMessage());
					    }	
				    }
			    }
		    }
		}
		catch(Exception $e)
		{
			Trace("\t".$node->getId().' '.$node->getName().' dot1port ==> IfIndex: ERROR: '.$e->getMessage());
		}
	}
	catch(Exception $e)
	{
		Trace($node->getId().' '.$node->getName().' SNMP ERROR: '.$e->getMessage());
	}
}
?>
