<?php
/**
 * @name sw_control-configuration.php
 * @description page incluse dans sw_control.php et gérant la configuration des switch (VLAN-status,etc)
 * @author Nicolas Biersart <n.biersart@esia-network.com>
 * @contributor
 * @copyright Nicolas Biersart 2012
 * @license
 * @esia 1.00
 * @version 1.0.0
 * @date 25/04/2013
 */
try
{
	$switch = $node->getName();
	$smarty->assign('sw_control_interface_view',$user->getDroits($dbconnection,"switch_interface_view",$switch));
//	echo get_class($node);
	$node->getInterfacesMib();
	//Recupère toutes les infortmations sur les interfaces (VLAN,mode,etc)
	$node->setAllVlanInterfacebySNMP();
	$node->setAllModeInterfacebySNMP();
	//on récupère le vlan databases
	$smarty->assign('sw_vlan_database',$node->getVlanDataBase());
	$smarty->assign('sw_mode_tab',$node->getModeDataBase());
	$smarty->assign('sw_control_name',$node->getName());
	$list=array();
	$oldints = Model_switch::getInterfaceInformation($dbconnection, $node->getId());
	foreach($node->getAllInterface() as $inter)
	{
		$status='down';
		if($inter->ifOperStatus==1)
		{
			$status='up';
		}
		else 
		{
			$lastoutput = secConvertTo(time()- $oldints[$inter->ifIndex]['ifLastChange']);
		}
		$list[]=array('access'=>1,
				'statut'=>$status,
				//'err' => $inter->getErrorMessage(),
				'name'=>$inter->ifDescr,
				'prise'=>$oldints[$inter->ifIndex]['plug'],
				'description'=>$oldints[$inter->ifIndex]['description'],
				'last_change_user'=>$oldints[$inter->ifIndex]['userLastChange'],
				'last_change_time'=>$oldints[$inter->ifIndex]['timeLastChange'],
				'AdminStatus' => $inter->getAdminStatusBySNMP(),
		        'vlan' => $inter->vlan,
		        'mode' => $inter->mode,
				'lastOut' => $lastoutput,
		);
	}
}
catch(interfaceException $e)
{
	echo $e->getMessage();
	$smarty->assign('l_sw_unsuported', $lang['SW_CTRL_SW_SNMP_UNSUPORTED']);
}
catch(SwitchUnsupportedManufacturerException $e)
{
	echo $e->getMessage();
	$smarty->assign('l_sw_unsuported', $lang['SW_CTRL_SW_SNMP_UNSUPORTED']);
}
catch(DeviceSNMPException $e)
{
	$smarty->assign('sw_host_no_response',$e->getMessage());
}
catch(SNMPException $e)
{
	$errors[]=array('id'=>'','name'=>'','status'=>$lang['SW_SNMP_FAILED']);
}
$smarty->assign('l_sw_reset', $lang['SW_RESET']);
$smarty->assign('l_sw_ctrl_tab_inter', $lang['SW_CTRL_SW_TAB_INTERFACE']);
$smarty->assign('l_sw_ctrl_tab_plug', $lang['SW_CTRL_SW_TAB_PLUG']);
$smarty->assign('l_sw_ctrl_tab_desc', $lang['SW_CTRL_SW_TAB_DESC']);
$smarty->assign('l_sw_ctrl_tab_login', $lang['SW_CTRL_SW_TAB_LOGIN']);
$smarty->assign('l_sw_ctrl_tab_voice', $lang['SW_CTRL_SW_TAB_VOICE_VLAN']);
$smarty->assign('l_sw_ctrl_tab_vlan', $lang['SW_CTRL_SW_TAB_VLAN']);
$smarty->assign('l_sw_ctrl_tab_mode', $lang['SW_CTRL_SW_TAB_MODE']);
$smarty->assign('l_sw_ctrl_tab_status', $lang['SW_CTRL_SW_TAB_STATUS']);
$smarty->assign('l_sw_ctrl_tab_admin_status', $lang['SW_IF_ADMINSTATUS']);
$_SESSION['listeInterface']=$list;
$_SESSION['switch']=$node->getName();
//Droit d'accès pour chacune des interfaces
if($user->getDroits($dbconnection,"switch_conf_voip",$switch) ==1)
	$smarty->assign('sw_conf_voip','1');
if($user->getDroits($dbconnection,"switch_conf_vlan_access",$switch) ==1)
	$smarty->assign('sw_conf_vlan_access','1');
if($user->getDroits($dbconnection,"switch_conf_vlan_trunk",$switch) ==1)
	$smarty->assign('sw_conf_vlan_trunk','1');
if($user->getDroits($dbconnection,"switch_conf_reset_access",$switch) ==1)
	$smarty->assign('sw_conf_reset_access','1');
if($user->getDroits($dbconnection,"switch_conf_reset_trunk",$switch) ==1)
	$smarty->assign('sw_conf_reset_trunk','1');
$smarty->assign('sw_list_interface',$list);
?>