<?php
function getLLDPMacAddressBySNMP(Device $node)
{
	$listmac = array();
	//on va maintenant récupérer les information sur les noeuds connectés via le LldpChassisIdSubtyp
	$result = $node->snmpwalkoid('1.0.8802.1.1.2.1.4.1.1.4');
	Trace("\t\t\tFCT:getLLDPMacAddressBySNMP:1.0.8802.1.1.2.1.4.1.1.4: success");
	foreach($result as $key => $value)
	{
		$type = formatInteger($value);
		//si le  LldpChassisIdSubtype il est égal à 4 ça signigie que le chassisID est égal à la mac address
		if($type == 4)
		{
			//on va récupérer l'id snmp du noeuds ainsi que le LLDPid du port du switch
			if(preg_match('#0\.8802\.1\.1\.2\.1\.4\.1\.1\.4\.([0-9\.]*)\.([0-9\.]*)\.([0-9\.]*)#',$key,$regs ))
			{
				$counter = $regs[1];
				$lldpid = $regs[2];
				$neighborid = $regs[3];
				//récupération de la mac adresse
				Trace("\t\t\tFCT:getLLDPMacAddressBySNMP:1.0.8802.1.1.2.1.4.1.1.5.$counter.$lldpid.$neighborid");
				$value='';
				//l'Alpine ne permet pas d'interroger en direct les oid donc si une erreur est levée on fera un test indirect.
				try
				{
					$value = $node->snmpget("1.0.8802.1.1.2.1.4.1.1.5.$counter.$lldpid.$neighborid");
				}
				catch(Exception $e)
				{
					$l_snmp_macaddress = $node->snmpwalkoid("1.0.8802.1.1.2.1.4.1.1.5");
					Trace($l_snmp_macaddress);
					foreach($l_snmp_macaddress as $key => $snmpmac)
					{
						$pattern = "#0\.8802\.1\.1\.2\.1\.4\.1\.1\.5.$counter\.$lldpid\.$neighborid#";
						if(preg_match($pattern,$key))
						{
							$value = $snmpmac;
							break;
						}
					}
				}
				Trace("\t\t\tFCT:getLLDPMacAddressBySNMP:1.0.8802.1.1.2.1.4.1.1.5.$counter.$lldpid.$neighborid SUCCESS $value");
				if(preg_match('#Hex-STRING#', $value))
				{
					$mac = formatHexString($value);
				}
				elseif(preg_match('#STRING#', $value))
				{
					$mac = formatString($value);
					$mac = preg_replace('#\:#'," " , $mac);
				}
				$listmac[]=array('mac'=>$mac,'lldpid'=>$lldpid,'neighborid'=>$neighborid,'counter'=>$counter);
			}
		}
	}
	return $listmac;
}
function Hex2String($hexStr)
{
	$string='';
	for ($i=0; $i < strlen($hexStr)-1; $i+=2)
	{
		$string .= chr(hexdec($hexStr[$i].$hexStr[$i+1]));
	}
	return $string;
}
function Trace($string)
{
	if(DEBUG!=0)
	{
		if(is_array($string))
			print_r($string);
			else
				echo "$string\n";
	}
}
//récupération du dot1dTpFdbPort (nécessaire pour récupéer les adresse mac par dot1port
function getdot1dTpFdbPort($snmp,$sw)
{
	$dot1port = array();
	$result = $snmp->snmpwalkoid($sw->getIPv4Adress(), '1.3.6.1.2.1.17.4.3.1.2');
	foreach($result as $key => $line)
	{
		$line = formatInteger($line);
		//on regarde que l'interface ne soit pas une interface trunk
		if(array_key_exists($line, $arrInterface))
		{
			//ce n'est pas une interface trunk. on va récupérer les mac adresses
			$line=$arrInterface[$line];
			$mac=null;
			if(preg_match('#\.3\.6\.1\.2\.1\.17\.4\.3\.1\.2\.([0-9\.]*)#',$key,$regs ))
			{
				//on a l'identifiant de la mac dans la mib on peut maintenant la récupérer
				$id = $regs[1];
				$mac = $snmp->snmpget($sw->getIPv4Adress(),'1.3.6.1.2.1.17.4.3.1.1.'.$id);
				$mac = formatHexString($mac);
			}
			//si la mac n'est pas vide on l'ajoute au tableau.
			if(!empty($mac))
			{
				//sert pour le debug.
				if(!array_key_exists($line,$dot1port ) )
				{
					$dot1port[$line] = array($mac);
				}
				else
				{
					$dot1port[$line] = array_merge($dot1port[$line],array($mac));
				}
			}
		}
	}
	return $dot1port;
}
?>