<?php
/**
 * @name sw_admin.php
 * @description page d'administration des switchs, gère les updates,insert,delete des switchs
 * @author Nicolas Biersart <n.biersart@esia-network.com>
 * @contributor
 * @copyright Nicolas Biersart 2012
 * @license
 * @esia 1.00
 * @version 1.00
 * @date 8/05/2013
 */
$path = $_SERVER['DOCUMENT_ROOT'];
include_once $path.'common.php';
include_once LIB_SNMP;

//chemin d'accès au repertoire du plugin contenant les templates
$arr = Model_esia::getWebPlugin($dbconnection,false,'Switch');
$template_path= $path.$arr[0]['apache_path'].'template/';

include_once $path.$arr[0]['apache_path']."model_switch.php";
$esialog = new EsiaLog(FILE_LOG,$user->getName());



//test des droits d'accès
if($user->getAccess($dbconnection,"esia_device") ==1)
{
	$smarty->assign('l_adm_sw_add', $lang['ADM_SW_ADD']);
	$smarty->assign('l_adm_sw_list', $lang['ADM_SW_LIST']);
	$action = $_GET['action'];
	$err=0;
	$dev_id=$_GET['id'];
	if(!isset($_GET['id']))
	{
		//si se n'est pas une modification/ajout  ou supression on redirige vers la gestion des noeuds
		header('Location: /administration.php?admin=device');
		exit();
	}
	if($action=='add')
	{
		try
		{
			$smarty->assign('action','add');
			$sw = new Switchs();
			//instancie un objet device
			$dev = Model_esia::InstanceNode($dbconnection,$dev_id);
			$sw->constructDevice($dev);		
			$smarty->assign('sw_id', $dev->getId());
			//on récupère l'OID du fabricant
			$objectid = $sw->getSysObjectId();
			$logo=null;
			include_once $path.'/libs/logo_oid.hash.php';
			$logo = IANA::getManufacturerLogo($objectid, $sw->getSysDescr());
			if($logo['name']!='none')
			{
				$newsw = Model_switch::getInstanceManufacturerSwitch($dbconnection,$logo['oid']);
				if(get_class($newsw)!='Switchs')
				{
					//on a une classe de gestion pour ce switch
					$newsw->constructDevice($dev);
					$sw = $newsw;
					$sw->setManufacturer($logo['oid']);
					//$sw->getOIDManufacturerBySNMP();
					$sw->setModelBySNMP();
					$sw->setOSBySNMP();
					$sw->setOSVersionBySNMP();
				}
			}
			//on récupère toutes les interfaces
			$sw->getInterfacesMib();
			foreach($sw->getAllInterface() as $int)
			{
				try
				{
					//regarde si le statut est up ou down
					if($int->getOperStatusBySNMP()==1)
					{
						$lastOut=0;
					}
					else
					{
						$ta = $int->getLastOutputBySNMP();
						if($ta!=-1)
						{
							$ta = $sw->getUpTime();
						}
						$lastOut=($ta['day']*24*60*60)+($ta['hour']*60*60)+($ta['minute']*60)+$ta['second'];
						$time = time();
						$lastOut= $time-$lastOut;
					}
					$int->ifLastChange = $lastOut;
				}
				catch(interfaceSNMPException $e)
				{
					//echo $e->getMessage();
					//$smarty->assign('error_snmp',$lang['ADM_SW_ADM_SNMP_DEVICE_FAILED'].'<br />'.$e->getMessage());
				}
			}
			//on insère les switchs de la DB
			Model_switch::insertSwitch($dbconnection,$sw);
			$smarty->assign('sw_manufacturer',$sw->getManufacturer());
			$smarty->assign('sw_model',$sw->getModel());
			$smarty->assign('sw_os', $sw->getOS());
			$smarty->assign('sw_os_version', $sw->getOSversion());
			$smarty->assign('adm_sw_treatok',$lang['SW_GEN_SW_UPDATE_DB']);
			//variable de langue 
			$smarty->assign('l_sw_name',$lang['SW_LIST_SW_NAME']);
			$smarty->assign('l_sw_manufacturer',$lang['SW_LIST_SW_MANUFACTURER']);
			$smarty->assign('l_sw_model',$lang['SW_LIST_SW_MODEL']);
			$smarty->assign('l_sw_os',$lang['SW_LIST_SW_OS']);
			$smarty->assign('l_sw_os_ver',$lang['SW_LIST_SW_OS_ver']);
			$esialog->write("SWITCH","INSERT switch ".$sw->getName());
			//$action='success_assign';
			/*header('Location: '.'/administration.php?admin=device&action=success_assign&id='.$sw->getId());
			exit();*/
		}
		catch(DeviceSNMPException $e)
		{
			$smarty->assign('error_snmp',$lang['ADM_SW_ADM_SNMP_DEVICE_FAILED'].'<br />'.$e->getMessage());
		}
		catch(SNMPException $e)
		{
			$smarty->assign('error_snmp',$lang['ADM_SW_ADM_SNMP_DEVICE_FAILED'].'<br />'.$e->getMessage());
		}
		catch(EsiaDbException $e)
		{
			$smarty->assign('adm_sw_INSERT_dev_FAILED',$e->getMessage());
			$smarty->assign('l_sw_add_insert_dev_FAILED', $lang['ADM_SW_ADD_INSERT_DEVICE_FAILED']);
		}
	}
	elseif($action=='update')
	{
		try
		{
			//nouveau switch
			$dev = Model_esia::InstanceNode($dbconnection,$dev_id); 	
			$smarty->assign('sw_id', $dev->getId());
			$sw = new Switchs();
			$sw->constructDevice($dev);	
			$smarty->assign('action','update');
			//on récupère l'OID du fabricant
			$objectid = $sw->getSysObjectId();
			$logo=null;
			include_once $path.'/libs/logo_oid.hash.php';
			$logo = IANA::getManufacturerLogo($objectid, $sw->getSysDescr());
			if($logo['name']!='none')
			{
				//si on a une classe personnalisé on tente d'aller chercher les infos complémentaire
				$newsw = Model_switch::getInstanceManufacturerSwitch($dbconnection,$logo['oid']);
				if(get_class($newsw)!='Switchs' && get_class($newsw)!=get_class($sw))
				{
					$newsw->constructDevice($dev);
					$sw = $newsw;
					$sw->setManufacturer($logo['oid']);
					$sw->setModelBySNMP();
					$sw->setOSBySNMP();
					$sw->setOSVersionBySNMP();
				}
			}
			$sw->getInterfacesMib();
			$list = $sw->getAllInterface();
			foreach($list as $int)
			{
				try
				{
					if($int->getOperStatusBySNMP() ==1)
					{
						$lastOut=0;
					}
					else
					{
						$ta = $int->getLastOutputBySNMP() ;
						if($ta!=-1)
						{
							$ta = $sw->getUpTime();
						}
						$lastOut=($ta['day']*24*60*60)+($ta['hour']*60*60)+($ta['minute']*60)+$ta['second'];
						$time = time();
						$lastOut= $time-$lastOut;
						
					}
					$int->lastout = $lastOut;
				}
				catch(interfaceSNMPException $e)
				{
					//echo $e->getMessage();
					//$smarty->assign('error_snmp',$lang['ADM_SW_ADM_SNMP_DEVICE_FAILED'].'<br />'.$e->getMessage());
				}
			}
			Model_switch::updateSwitch($dbconnection,$sw);
			$smarty->assign('sw_manufacturer',$sw->getManufacturer());
			$smarty->assign('sw_model',$sw->getModel());
			$smarty->assign('sw_os', $sw->getOS());
			$smarty->assign('sw_os_version', $sw->getOSversion());
			$smarty->assign('adm_sw_treatok',$lang['SW_GEN_SW_UPDATE_DB']);

			//echo $sw->getId();
			//echo '/administration.php?admin=device&action=success_assign&id='.$sw->getId();
			//header('Location: '.'/administration.php?admin=device&action=success_assign&id='.$sw->getId());
		//	exit();
			$esialog->write("SWITCH","UPDATE switch ".$sw->getName());
		}
		catch(DeviceSNMPException $e)
		{
			$smarty->assign('error_snmp',$lang['ADM_SW_ADM_SNMP_DEVICE_FAILED'].'<br />'.$e->getMessage());
		}
		catch(EsiaDbException $e)
		{
			$smarty->assign('adm_sw_INSERT_dev_FAILED',$e->getMessage());
			$smarty->assign('l_sw_add_insert_dev_FAILED', $lang['ADM_SW_ADD_INSERT_DEVICE_FAILED']);
		}
	}
	elseif($action=='delete')
	{
		Model_switch::deleteSwitch($dbconnection,$dev_id);
		$smarty->assign('l_adm_delete_success',$lang['ADM_DELETE_SUCCESS']);
	}
}
else
{
	$smarty->assign('l_no_access', $lang['NO_ACCESS']);
}
$smarty->display($template_path.'sw_admin.html');

?>