<?php
/**
 * @name sw_control.php
 * @description Fichier principal du plugin serveur
 * @author Nicolas Biersart <n.biersart@esia-network.com>
 * @contributor
 * @copyright Nicolas Biersart 2012
 * @license
 * @esia 1.00
 * @version 1.0.0
 * @date 3/11/2014
 */

//inclusion des fichiers principaux
$path = $_SERVER['DOCUMENT_ROOT'];
include_once $path.'common.php';
$temps = microtime();
$temps = explode(' ', $temps);
$debut = $temps[1] + $temps[0];
if(isset($_GET['id']) && !empty($_GET['id']))
{
    $_GET['nodeid'] = $_GET['id'];
}
$webp_name='Switch';
$webp_model='model_switch.php';
//Inclusion des librairie
/*DESCRIPTION: inclus les variables habituelles pour la gestion d'un noeud et vérifie les droits d'accès
 *NECESSITE: la variable $webp_name configurée
 *           la variable $webp_model est incluste
 *APRES l'inclusion du common_node_control les variables suivantes sont créées:
 *PHP:
 *      $node objet de type device
 *      $template_path chemin d'accès vers le répertoire template du plugin (exemple: /usr/local/esia/public_html/plugin/server/templates/)
 *      $apache_plugin_path chemin apache du plugin (exemple: /plugin/server/)
 *      $node_info = array('id'=>$node->getId(),
 'name'=>$node->getName(),
 'ip'=>$node->getIPAddress(),
 'id'=>$node->getId(),
 'description'=>$node->getDescription(),
 'group'=>$node->getGroup());
 * SMARTY
 $webp_name nom du plugin
 $node avec les donnée de node_info (voir au dessus)
 *      $apache_path chemin apache du plugin (exemple: /plugin/server/)
 *      $node_status pour l'affichage commun des noeuds si $_GET['tab'] est vide
 *
 */
include_once $path.'/inc/common_node_control.php';

if(!isset($_GET['action'])&&empty($_GET['action']))
{
	$_GET['action']='';
	$smarty->assign('sw_action', '');
}
$smarty->assign('sw_control_id',$node->getId());
$smarty->assign('sw_control_name',$node->getName());
//affichage de quelques informations général sur le noeud
$smarty->assign('action',$_GET['action']);
if(@get_class($node)!='RemoteSwitch' && @get_class($node)!='RemoteDevice')
{
	//print_r($dbinfo);
	if($user->getDroits($dbconnection,"switch_interface_view"))
	{
		$smarty->assign('USL','yes');
	}
}
if(isset($_GET['interface'])&&!empty($_GET['interface']))
{
	$smarty->assign('searchinterface',$_GET['interface']);
	$arr = Model_switch::getInterfaceInformation($dbconnection,$node->getId(),$_GET['interface']);
	$inter = reset ($arr);
	$smarty->assign('inter',$inter);
}
//variable de langue
$smarty->assign('l_information', $lang['INFORMATION_NODE']);
$smarty->assign('l_state_service', $lang['SERVICE_STATE']);
$smarty->assign('l_state_service_passifcheck', $lang['SERVICE_STATE_CHECK_PASSIF']);
$smarty->assign('l_show_service', $lang['SHOW_SERVICE']);
$smarty->assign('l_show_historic', $lang['SHOW_HISTORIC']);
$smarty->assign('l_show_graph', $lang['SHOW_GRAPH']);
$smarty->assign('l_report', $lang['REPORT']);
$smarty->assign('l_sw_page_exe', $lang['SRV_PAGE_EXE']);
$smarty->assign('l_sw_page_exe_time', $lang['SRV_PAGE_EXE_TI']);
$smarty->assign('l_sw_ctrl_lgd_title', $lang['SW_CTRL_SW_LGD_TITLE']);
$smarty->assign('l_sw_ctrl_lgd_ok', $lang['SW_CTRL_SW_LGD_OK']);
$smarty->assign('l_sw_ctrl_lgd_down', $lang['SW_CTRL_SW_LGD_DOWN']);
$smarty->assign('l_sw_ctrl_lgd_warn', $lang['SW_CTRL_SW_LGD_WARN']);
$smarty->assign('l_sw_ctrl_lgd_cri', $lang['SW_CTRL_SW_LGD_CRI']);
$smarty->assign('l_type_node', $lang['ADM_NODE_TYPE']);
$smarty->assign('l_description', $lang['ADM_DESCRIPTION']);
$smarty->assign('l_address_ip', $lang['ADM_ADDR_IP']);
$smarty->assign('l_group', $lang['ADM_GRP']);
$smarty->assign('l_device', $lang['DEVICE']);
$smarty->assign('l_interface', $lang['ADM_SW_ADD_INTERFACE']);
$smarty->assign('l_loading', $lang['LOADING']);
$smarty->assign('l_sw_intloading', $lang['SW_INT_LOAD']);
$smarty->assign('l_modification', $lang['MODIF']);
//affichage de la page
$temps = microtime();
$temps = explode(' ', $temps);
$fin = $temps[1] + $temps[0];
// On affiche la différence entre des deux valeurs

$smarty->assign('execute_time',round(($fin - $debut),6) );
$smarty->display($template_path.'sw_control.html');
?>
