<?php
/**
 * @name sw_createConf.php
 * @description Page créant les configurations pour les switch et les charges sur ceux-ci 
 * @author Nicolas Biersart <n.biersart@esia-network.com>
 * @contributor
 * @copyright Nicolas Biersart 2012
 * @license
 * @esia 1.00
 * @version 1.0.0
 * @date 18/04/2013
 */
$path = $_SERVER['DOCUMENT_ROOT'];
include_once $path.'common.php';
//chemin d'accès au repertoire du plugin contenant les templates
$arr = Model_esia::getWebPlugin($dbconnection,false,'Switch');
$template_path= $path.$arr[0]['apache_path'].'template/';
include_once $path.$arr[0]['apache_path']."model_switch.php";
include_once $path.$arr[0]['apache_path']."/libs/switch.class.php";
include_once $path.$arr[0]['apache_path']."/libs/USL.class.php";
$esialog = new EsiaLog(FILE_LOG,$user->getName());
$temps = microtime();
$temps = explode(' ', $temps);
$debut = $temps[1] + $temps[0];
//on vérifie qu'on vient bien de la page sw_control avec le mode de configuration d'interface.
//Evite de contourner certaine sécurité.
if ((!isset($_SESSION['listeInterface']) || !is_array($_SESSION['listeInterface']))&&isset($_GET['interface']))
{
	//on ne vient pas de la bonne page on est redirigé
	header("Location: ".$path."index.php");
	exit();
}
//chemin d'accès au repertoire du plugin contenant les templates
$arr = Model_esia::getWebPlugin($dbconnection,false,'Switch');
$template_path= $path.$arr[0]['apache_path'].'template/';
//on récupère le nom du switch
$switch=$_POST['switch'];
if($user->getDroits($dbconnection,"device_view",$switch) ==1 && $user->getDroits($dbconnection,"switch_interface_view",$switch) ==1 && $_SESSION['switch']== $switch)
{
	try
	{
		//on a les droits d'accès.
		//on récupère les information sur le switch qui se trouve en DB
		$sw = Model_switch::InstanceSwitch($dbconnection,$switch);
		$sw->getInterfacesMib();
		$action=$_POST['action'];
		if ( $action == "updater" )
		{
			//on update la conf
			//on récupère les listes des interfaces
			$list_inter= $_SESSION['listeInterface'];
			session_write_close();
			$smarty->assign('l_sw_alive_success', $lang['SW_GEN_SW_ALIVE_SUCCESS']);
			//mise à jour des prises et des descriptions
			foreach($list_inter as $inter)
			{
				
				$interface = $inter['name'];
				$desc= $_POST[$interface.'-Desc'];
				$prise= $_POST[$interface.'-prise'];
				$int = new Interfaces();
				$change=0;
				$int->name = $interface;
				//si on a modifié la prise on update
				if($inter['prise']!=$prise)
				{
					$change=1;
					$int->plug = $prise;
				}		//si on a modifié la description on update l'interface (commande "Description de l'USL")
				if($inter['description']!=$desc)
				{
					$change=1;
					$new_desc = strtr($desc,
							'ÀÁÂÃÄÅÇÈÉÊËÌÍÎÏÒÓÔÕÖÙÚÛÜÝàáâãäåçèéêëìíîïðòóôõöùúûüýÿ',
							'AAAAAACEEEEIIIIOOOOOUUUUYaaaaaaceeeeiiiioooooouuuuyy');
					$int->description = $new_desc;
				}
				if($change==1)
				{
					//on update l'interface au niveau DB
					Model_switch::updateSwitchInterfaceInformation($dbconnection,$sw->getId(),$int,$user->getName());
				}
			}
			$smarty->assign('l_sw_up_db_success', $lang['SW_GEN_SW_UPDATE_DB_SUCCESS']);
			//on initialise USL
			$usl = new USL($sw->getConfigurationTemplate());
			$usl->ConfSwitch();
			///on passe en revue les interfaces une à une afin de trouver celle qu'on souhaite modifier
			foreach($list_inter as $inter)
			{
				$int = new Interfaces();
				$change=0;
				$interface = $inter['name'];
				$portmode= $_POST[$interface.'-mode'];
				$vlanid= $_POST[$interface.'-vlanid'];
				$admStatus= $_POST[$interface.'-admStatus'];
				$desc= $_POST[$interface.'-Desc'];
				$prise= $_POST[$interface.'-prise'];
				//si on a modifié la prise on update
				if($inter['prise']!=$prise)
				{
					$change=1;
				}		//si on a modifié la description on update l'interface (commande "Description de l'USL")
				if($inter['description']!=$desc)
				{
					$change=1;
					$new_desc = strtr($desc,
							'ÀÁÂÃÄÅÇÈÉÊËÌÍÎÏÒÓÔÕÖÙÚÛÜÝàáâãäåçèéêëìíîïðòóôõöùúûüýÿ',
							'AAAAAACEEEEIIIIOOOOOUUUUYaaaaaaceeeeiiiioooooouuuuyy');
					$int->description = $new_desc;
				}
				else
				{
					$new_desc = $inter['description'];
				}
				//test de l'admin status
				if(!empty($admStatus))
				{
    				if($inter['AdminStatus'] != $admStatus)
    				{
    					$change = 1;
    					if($admStatus==1)
    						$int->ifAdminStatus = 'up';
    					elseif($admStatus==2)
    						$int->ifAdminStatus = 'down';
    				}
				}
				//On vérifier les mode de fonctionnement. S'il a changé on modifie également le VLAN
				if(!empty($portmode))
				{
    				if($inter['mode']!=$portmode&&$inter['mode']!='none')
    				{
    					//echo $inter['mode'].'=='.$portmode.'<br />';
    					$int->mode=$portmode;
    					$int->vlan=$vlanid;
    					$change=1;
    				}//si le mode est le même on vérifier le VLANID
    				elseif($inter['vlan']!=$vlanid &&$inter['vlan']!=-1)
    				{
    					$int->mode = $portmode;
    					$int->vlan = $vlanid;
    					$change=1;
    				}
				}
				//Test si on reset l'interface
				if(isset($_POST[$interface.'-reset']))
				{
					//echo "reset $interface<br />";
					$int->reset=1;
					$change=1;
				}
				if($change==1)
				{
					//on prépare pour les changements demandé
					$int->name = $interface;
					$int->plug = $prise;
					$int->description= $new_desc;
					//on génère les commandes
					$usl->ConfInterface($int);
					//on update l'interface au niveau DB
					//Model_switch::updateSwitchInterfaceInformation($dbconnection,$sw->getId(),$int,$user->getName());
				}
			}
			$usl->endConfiguration();
		}
		elseif($action=='updateSNMP')
		{
			$sw->getHostAliveBySNMP();
			$smarty->assign('l_sw_alive_success', $lang['SW_GEN_SW_ALIVE_SUCCESS']);
			//on initialise USL
			$usl = new USL($sw->getConfigurationTemplate());
			$usl->ConfSwitch();

			//configuration RMONEvent 14 =  ifinerror
			$usl->getUSL()->command('rmon event',14,$sw->getSNMPObject()->getCommunity(),'High IfInErrors','InError');
			$usl->getUSL()->command('snmp linkNotification','linkdown linkup');
			$usl->getUSL()->command('snmp macNotification');
			//on récupère les listes des interfaces
			$list_inter= $_SESSION['listeInterface'];
			///on passe en revue les interfaces une à une afin de trouver celle qu'on souhaite modifier
			$i=0;
			foreach($list_inter as $inter)
			{
				$int = $sw->getInstanceNetworkInterface() ;
				$int->setIfIndex($inter['ifindex']);
				$ifindex = $int->getIfIndex();
					
				//On récupère toutes les valeurs du formulaire
				$int->setName($inter['name']);
				$int->setCriticalInterface($inter['criticalInterface']);
				$LinkEnabled = 'disable';
				$MacEnabled = 'disable';
				$InErrorEnabled = 0;
				if(isset($_POST[$ifindex.'-criticalLink']))
				{
					$int->setCriticalInterface(1);
				}
				if(isset($_POST[$ifindex.'-trapLink']))
				{
					$LinkEnabled = 'enable';
				}
				if(isset($_POST[$ifindex.'-MacNotification']))
				{
					$MacEnabled = 'enable';
				}
				if(isset($_POST[$ifindex.'-ifInerror']))
				{
					$InErrorEnabled = 1;
				}
				$change=0;
				//on regarde si il n'y a pas de changement
				if($int->getCriticalInterface() !=$inter['criticalInterface'])
				{
					$change=1;
				}
				if($LinkEnabled !=$inter['linkTrap'])
				{
					$change=1;
				}
				if($MacEnabled !=$inter['MacTrap'])
				{
					$change=1;
				}
				if($InErrorEnabled !=$inter['InError'])
				{
					$change=1;
				}
				//Si il y a eu un changement on charge l'USL sur l'interface
				if($change==1)
				{
					$usl->getUSL()->confmode('configuration');;
					if($InErrorEnabled !=$inter['InError'])
					{
						//print_r($int);
						$alarmnum = '14'.$int->getIfIndex();
						if($InErrorEnabled==0)
							$usl->getUSL()->command('no rmon alarm',"$alarmnum","1.3.6.1.2.1.2.2.1.14.".$int->getIfIndex() ,$_POST['sampleinterval'],$_POST['rising-threshold'],'14','1','InErrors');
						else
							$usl->getUSL()->command('rmon alarm',"$alarmnum","1.3.6.1.2.1.2.2.1.14.".$int->getIfIndex() ,$_POST['sampleinterval'],$_POST['rising-threshold'],'14','1','InErrors');
					}
					$usl->getUSL()->confmode('interface',$int->getName());
					if($LinkEnabled !=$inter['linkTrap'])
					{
						if($LinkEnabled=='disable')
							$usl->getUSL()->command('no snmp linkNotification');
						else
							$usl->getUSL()->command('snmp linkNotification');
					}
					if($MacEnabled !=$inter['MacTrap'])
					{
						if($MacEnabled=='disable')
							$usl->getUSL()->command('no snmp macNotification');
						else
							$usl->getUSL()->command('snmp macNotification');
					}
					$usl->getUSL()->exitmode();
					Model_switch::updateSwitchInterfaceCritical($dbconnection,
							$sw->getId(),
							$int->getCriticalInterface(),
							$int->getIfIndex(),
							$user->getName());
				}
			}
			$usl->endConfiguration();
			//echo $usl->getGenerateConfigurationHTML();
		}
		$smarty->assign('l_sw_up_db_success', $lang['SW_GEN_SW_UPDATE_DB_SUCCESS']);
		//La génération est un succès. Variables de langue mise au vert
		$smarty->assign('l_sw_gen_tpl_found', $lang['SW_GEN_SW_TEMPLATE_FOUND']);
		$smarty->assign('l_sw_gen_conf_success', $lang['SW_GEN_SW_CONF_SUCCESS']);
		$smarty->assign('l_sw_gen_conf', $lang['SW_GEN_SW_GEN_CONF']);
		
		//on récupère le repertoire des fichiers de log
		$rep = Model_switch::getLogFilePath($dbconnection);
		//on crèe le nom du fichier
		$filename = $rep.$switch."-".date("d-m-Y_H:i:s").".conf.txt";
		$smarty->assign('sw_gen_filename',$filename);
		$file=fopen($filename,"w+");
		//si on est pas arriver à ouvrir le fichier
		if($file===FALSE)
		{
			$smarty->assign('l_sw_gen_save_file_failed', $lang['SW_GEN_SW_SAVE_FILE_FAILED']);
		}
		else
		{
			//sauvegarde de la configuration
			$smarty->assign('l_sw_gen_save_file_success', $lang['SW_GEN_SW_SAVE_FILE_SUCCESS']);
			fwrite($file,$usl->getGenerateConfiguration());
			fclose($file);
			//$sw->setConnectionID(SW_USER,SW_PWD);
			$sw->setConnectionID('admin','D3idr3UnsweetenedUnharm3d');
			$sw->setTypeConnection(Device::SSH);
			
			//upload de la configuration sur le switch
			$c = $sw->uploadConfiguration($usl->getGenerateConfiguration());
			$esialog->write('SWITCH', 'upload configuration success. File: '.$filename);
			//$c = $sw->uploadFileConfiguration($filename);
			$smarty->assign('sw_configuration',preg_replace('#\n#', '<br />', $usl->getGenerateConfiguration()));
			$smarty->assign('l_sw_gen_upload_conf_success', $lang['SW_GEN_SW_UPLOAD_CONF_SUCCESS']);
		}
	}
	catch(DeviceNotAliveException $e)
	{
		$smarty->assign('l_sw_snmp_failed', $lang['SW_GEN_SW_ALIVE_FAILED']);
	}
	catch(SwitchUnsupportedManufacturerException $e)
	{
		$smarty->assign('l_sw_up_tpl_failed',$lang['SW_CTRL_SW_MANUFACTURER_UN']);
	}
	catch(SwitchNoConfigurationTemplateException $e)
	{
		$smarty->assign('l_sw_up_tpl_failed',$lang['SW_CTRL_SW_NO_TEMPLATE']);
	}
	catch(SwitchConnectionFailedException $e)
	{
		$smarty->assign('sw_connection_failed',$lang ['ADM_SW_ADD_TELNET_FAILED']);
	}
	catch(USLException $e)
	{
		$smarty->assign('l_sw_up_tpl_failed',$lang['SW_CTRL_SW_NO_TEMPLATE']);
	}
	catch(EsiaDbException $e)
	{
		$smarty->assign('l_sw_up_db_failed', $lang['SW_GEN_SW_UPDATE_DB_FAILED']);
	}
}
//Instanciation des variables de langue
$smarty->assign('l_sw_gen_action', $lang['SW_GEN_SW_TABLE_ACTION']);
$smarty->assign('l_sw_gen_status', $lang['SW_GEN_SW_TABLE_STATUS']);
$smarty->assign('l_sw_gen_template', $lang['SW_GEN_SW_TEMPLATE']);
$smarty->assign('l_sw_gen_conf', $lang['SW_GEN_SW_CONF']);
$smarty->assign('l_sw_gen_up_db', $lang['SW_GEN_SW_UPDATE_DB']);
$smarty->assign('l_sw_gen_upload_conf', $lang['SW_GEN_SW_UPLOAD_CONF']);
$smarty->assign('l_sw_alive', $lang['SW_GEN_SW_ALIVE']);
$smarty->assign('l_sw_gen_save_file', $lang['SW_GEN_SW_SAVE_FILE']);
$smarty->assign('l_sw_gen_failed', $lang['SW_GEN_SW_FAILED']);
//affichage de la page
$temps = microtime();
$temps = explode(' ', $temps);
$fin = $temps[1] + $temps[0];
// On affiche la différence entre des deux valeurs
$smarty->assign('l_sw_index_page_exe', $lang['SW_INDEX_PAGE_EXE']);
$smarty->assign('l_sw_index_page_exe_time', $lang['SW_INDEX_PAGE_EXE_TI']);
$smarty->assign('execute_time',round(($fin - $debut),6) );
$smarty->display($template_path.'sw_createConf.html');
?>
