<?php
/**
 * @name sw_control.php
 * @description Fichier principal du plugin serveur
 * @author Nicolas Biersart <n.biersart@esia-network.com>
 * @contributor
 * @copyright Nicolas Biersart 2012
 * @license
 * @esia 1.00
 * @version 1.0.0
 * @date 3/11/2014
 */

//inclusion des fichiers principaux
$path = $_SERVER['DOCUMENT_ROOT'];
include_once $path.'common.php';
include_once $path.'/Model_adm.php';
$temps = microtime();
$temps = explode(' ', $temps);
$debut = $temps[1] + $temps[0];
if($licence['type'] =='universe' || $licence['type'] =='unity')
{
    $smarty->assign('esia_type','cloud');
}
else
{
    $smarty->assign('esia_type','enterprise');
}
//on récupère le nom du serveur
if(isset($_REQUEST['id']))
{
    $_GET['nodeid'] = $_REQUEST['id'];
}
$webp_name='Switch';
$webp_model='model_switch.php';
//Inclusion des librairie
/*DESCRIPTION: inclus les variables habituelles pour la gestion d'un noeud et vérifie les droits d'accès
 *NECESSITE: la variable $webp_name configurée
 *           la variable $webp_model est incluste
 *APRES l'inclusion du common_node_control les variables suivantes sont créées:
 *PHP:
 *      $node objet de type device
 *      $template_path chemin d'accès vers le répertoire template du plugin (exemple: /usr/local/esia/public_html/plugin/server/templates/)
 *      $apache_plugin_path chemin apache du plugin (exemple: /plugin/server/)
 *      $node_info = array('id'=>$node->getId(),
 'name'=>$node->getName(),
 'ip'=>$node->getIPAddress(),
 'id'=>$node->getId(),
 'description'=>$node->getDescription(),
 'group'=>$node->getGroup());
 * SMARTY
 $webp_name nom du plugin
 $node avec les donnée de node_info (voir au dessus)
 *      $apache_path chemin apache du plugin (exemple: /plugin/server/)
 *      $node_status pour l'affichage commun des noeuds si $_GET['tab'] est vide
 *
 */
include_once $path.'/inc/common_node_control.php';
include_once './model_switch.php';
include_once "./libs/USL.class.php";
include_once "./libs/smarty.function.swInterface.php";
include_once $path.'/libs/convert.lib.php';
$node = Model_switch::InstanceSwitch($dbconnection, $node->getId());
if(!isset($_GET['action'])&&empty($_GET['action']))
{
	$_GET['action']='';
}
$smarty->assign('action',$_GET['action']);

$errors=array();
$smarty->assign('sw_control_id',$node->getId());
if($user->getDroits($dbconnection,"switch_interface_view"))
{
	$smarty->assign('user_switch_interface_view',$user->getDroits($dbconnection,"switch_interface_view"));
	if($_GET['action']=='USL')
	{
		include './inc/sw_control-configuration.inc.php';
	}
}
session_write_close();
if($_GET['action']=='stat')
{
	//on récupère toutes les interfaces
	$inter = $node->getInterfaceStat($_GET['ifindex']);
	$status='down';
	if($inter->ifOperStatus==1)
	{
		$status='up';
	}
	$humanInOctet= Convert\bytes($inter->ifInOctets);
	$humanOutOctet= Convert\bytes($inter->ifOutOctets);
	$data[$i]["hrStorageSize"]=$humanInOctet['value'].' '.$humanInOctet['unity'];
	$interface=array('id'=>$inter->ifIndex,
				'description'=>$inter->ifDescr,
				'name'=>$inter->ifName,
				'status'=>$status,
	            'inoctet'=>$humanInOctet['value'].' '.$humanInOctet['unity'],
	             'outoctet'=>$humanOutOctet['value'].' '.$humanOutOctet['unity'],
				'inerror'=>$inter->ifInErrors,
				'outerror'=>$inter->ifOutErrors,
				'mtu'=>$inter->ifMtu,
				'speed'=>($inter->ifSpeed/1000/1000).' Mb/s',
				'alias'=>$inter->ifAlias );
		 $date = new DateTime();
		$nbrsec = (int) ($inter->ifLastChange/100);
		$uptime = new  DateInterval("PT".$nbrsec."S");
		$uptime = $date->sub($uptime);
		$smarty->assign('uptime',$uptime->format('d/m/Y H:i:s') );
		//$interfaces[]=array('id'=>$ts[0],'name'=>$ts[1],'statut'=>$status);
		$smarty->assign('interface',$interface);
		if(@get_class($node)!='RemoteSwitch')
		{
			$dbinfo = Model_switch::getInterfaceInformation($dbconnection,$node->getId(),$inter->ifIndex);
			//print_r($dbinfo);
			if($user->getDroits($dbconnection,"switch_interface_view")){
				$smarty->assign('USL','yes');
			}
			$smarty->assign('dbinfo_interface',$dbinfo[$inter->ifIndex]);
		}
}
elseif($_GET['action']=='statsinterface')
{
	$smar_list = array();
	$interfaces = $node->getInterfacesMib('all');
    //echo '<pre>'.print_r($interfaces).'</pre>';
	foreach ($interfaces as $inter)
	{
		$int = $node->getInterfaceStat($inter->ifIndex,'brief');
					$status='down';
		if($inter->ifOperStatus==1)
		{
			$status='up';
		}
		$adminStatus='testing';
		if($inter->ifAdminStatus==1)
		{
			$adminStatus='up';
		}
		elseif($inter->ifAdminStatus==2)
		{
			$adminStatus='down';
		}
        $speed = $inter->ifSpeed/1000/1000;
        if($speed >=1000)
        {
            $speed = ($speed/1000).' Gb/s';
        }
        else
        {
             $speed.=' Mb/s';
        }
        $humanInOctet= Convert\bytes($inter->ifInOctets);
        $humanOutOctet= Convert\bytes($inter->ifOutOctets);
		$tmp=array('id'=>$inter->ifIndex,
				'description'=>$inter->ifDescr,
				'name'=>$inter->ifName,
				'status'=>$status,
				'inoctet'=>$int->ifInOctets,
		        'inoctetConvert'=>$humanInOctet['value'].' '.$humanInOctet['unity'],
				'outoctet'=>$int->ifOutOctets,
		        'outoctetConvert'=>$humanOutOctet['value'].' '.$humanOutOctet['unity'],
				'inerror'=>$int->ifInErrors,
				'outerror'=>$int->ifOutErrors,
				'mtu'=>$inter->ifMtu,
				'speed'=>$inter->ifSpeed,
				'convertspeed'=>$speed,
				'alias'=>$inter->ifAlias,
				 'adminStatus'=>$adminStatus);
		$smar_list[]=$tmp;
	}
	$smarty->assign('sw_interfaces',$smar_list);
}
elseif($_GET['action']=='stp')
{
	$arr = $node->snmpwalkoid('.1.3.6.1.2.1.17.1.4.1.2');
	foreach($arr as $key => $ifindex)
	{
		$ifindex = formatInteger($ifindex);
		preg_match('#\.([0-9]*)$#',$key,$regs);
		$index = $regs[1];
		$ForwardTransitions  = $node->snmpget('.1.3.6.1.2.1.17.2.15.1.10.'.$index);
		$name = $node->snmpget('.1.3.6.1.2.1.2.2.1.2.'.$ifindex);
		$list[]=array('ifindex'=>$ifindex,
				'name'=>formatString($name),
				'ForwardTransitions'=>formatInteger($ForwardTransitions)	);

	}
	$smarty->assign('sw_list_stp',$list);
}
elseif($_GET['action']=='entity')
{
	try
	{
		$arr = $node->snmpwalkoid('.1.3.6.1.2.1.47.1.1.1.1.13');
		foreach($arr as $key => $model)
		{
			$model = formatString($model);
			if(!empty($model))
			{
				preg_match('#\.([0-9]*)$#',$key,$regs);
				$index = $regs[1];
				$name = $node->snmpget('.1.3.6.1.2.1.47.1.1.1.1.7.'.$index);
				$serialnumber= $node->snmpget('.1.3.6.1.2.1.47.1.1.1.1.11.'.$index);
				$hardwarerev= $node->snmpget('.1.3.6.1.2.1.47.1.1.1.1.8.'.$index);
				$firmwarerev = $node->snmpget('.1.3.6.1.2.1.47.1.1.1.1.9.'.$index);
				$softwarerev = $node->snmpget('.1.3.6.1.2.1.47.1.1.1.1.10.'.$index);
				$physicaldescript = $node->snmpget('.1.3.6.1.2.1.47.1.1.1.1.2.'.$index);

				$remplaceable = $node->snmpget('.1.3.6.1.2.1.47.1.1.1.1.16.'.$index);
				$list[]=array('model'=>$model,
						'name'=>formatString($name),
					      'serialnumber'=>formatString($serialnumber),
					      'hardware'=>formatString($hardwarerev),
					      'firmware'=>formatString($firmwarerev),
					      'software'=>formatString($softwarerev),
					      'physical_desc'=>formatString($physicaldescript),
					      'remplaceable'=>formatInteger($remplaceable) );


			}
		}
	}
	catch(SNMPException $e)
	{
		$errors[]=array('id'=>'','name'=>'','status'=>$lang['SW_SNMP_FAILED']);
	}
	$smarty->assign('sw_list_entity',$list);
}
elseif($_GET['action']=='connected')
{
	$arr = Model_switch::getScanState($dbconnection,$node->getId());
	$smarty->assign('scan_state', $arr['state']);
	$smarty->assign('scan_time', $arr['lasttime']);
	$listInter = Model_switch::getNodeConnected($dbconnection, $node->getId());
	$listmacadress = Model_switch::getNodeMACConnected($dbconnection, $node->getId());
	$list = array();
	foreach($listInter as $inter)
	{
		$connectedto=array();
		//echo '<pre>'.print_r($inter['nodes'],true).'</pre>';
		//echo 'test inter '.$inter['nodes'][0]['id'].'<br />';
		if(!empty($inter['nodes'][0]['id']))
		{
			foreach($inter['nodes'] as $tmpnode)
			{
				if(!empty($tmpnode['id']))
				{
					//on vérifier les droits d'accès
					if($user->getAccess($dbconnection, 'device_view',$tmpnode['name']))
					{
						//print_r($tmpnodes);
						$tmp =  Model_esia::InstanceNode($dbconnection, $tmpnode['id']);
						$page_control = Model_esia::getPageControl($dbconnection, $tmp->getType() );
						if($page_control!=null)
						{
							$page_control = Model_esia::replacePageControlVariable($page_control,$tmp);
						}
						else
						{
							$page_control = '/node_view.php?name='.$tmp->getId();
						}
						$connectedto[]=array('name' =>$tmp->getName(),'pageControl'=>$page_control,'mac'=>$tmpnode['mac'],
							'type_img'=>$ICONS[$tmp->getType()],'ip'=>$tmp->getIPv4Adress(),
							'protocol'=> $tmpnode['protocol'],'vendor'=>$tmpnode['vendor']);
					}
				}
			}
		}
		else
		{
			//echo 'ici'.$inter['interface_id'].'<br >';
			//			echo '<pre>'.print_r($listmacadress[$inter['interface_id']],true).'</pre>';
			foreach($listmacadress[$inter['interface_id']] as $mac)
			{
				$connectedto[]=array('name' =>$mac['description'],'pageControl'=>null,'mac'=>$mac['mac'],
					'type_img'=>null,'ip'=>null,
					'protocol'=> $mac['protocol'],'vendor'=>$mac['vendor']);
			}
		}
		$list[] = array('id'=>$inter['interface_id'],'name'=>$inter['interface_name'] ,'ifindex'=>$inter['interface_ifindex'],'nodes'=> $connectedto);
	}
	//echo '<pre>';print_r($list); echo '</pre>';
	$smarty->assign('connectedto', $list);
}
elseif($_GET['action']=='graphinterfaces')
{
	if(@get_class($node)!='RemoteSwitch')
	{
		$pl_name = 'CHECK_SNMP_SW_INTERFACE_EASY';
	}
	else
	{
		$pl_name = 'GESA_SNMP_SW_INTERFACE_EASY';
	}
	$plugin = Model_esia::getPlugin($dbconnection,$pl_name);
	$plugin = $plugin[0];
	$pl_name = preg_replace('#EASY#','',$pl_name);

	$interfaces = $node->getInterfacesMib('all');
		//on ajoute un nouveau test.
	//echo $node->getSNMPVersion();
	if($_GET['admin']=='addservice')
	{
		if(isset($_POST['maxsensors']) && $_POST['maxsensors'] >0 && $_POST['maxsensors']<1000)
		{
		    foreach ($interfaces as $inter)
			{
				$i = $inter->ifIndex;
				if(isset($_POST[$i])&&is_numeric($_POST[$i]))
				{
					$param = preg_replace('#<ifindex>#',$_POST[$i],$plugin['parameter']);
					if($node->getSNMPVersion()==3)
					{
						$seclevel = $node->getSNMPObject()->getSNMP3SecLevel();
						if($seclevel == 'authPriv') 
						{
							$param = preg_replace('#\-C\s+\$SNMP_COM#','-U $SNMP3_USER -A $SNMP3_AUTH_KEY -P $SNMP3_PRIV_KEY --level $SNMP3_AUTH_PROT,$SNMP3_PRIV_PROT',$param);
						}
						else
						{
							$param = preg_replace('#\-C\s+\$SNMP_COM#','-U $SNMP3_USER -A $SNMP3_AUTH_KEY --level $SNMP3_AUTH_PROT',$param);
						}
					}
					$interface_name = $_POST["$i-name"];
					if(empty($_POST["$i-name"]) || $_POST["$i-name"]=="Ethernet Interface")
					{
						$interface_name = $_POST[$i]; //Si nom est vide ou = à Ethernet Interface pour D-LINK toutes égales on met l'index
					}
					Model_adm::addService($dbconnection,$pl_name.$interface_name ,$plugin['id'],$node->getId(),300000,$param,2,null,null,null,null,null);
				}
            }
            $redirection= $arr[0]['apache_path'].'/sw_control.php?id='.$node->getId();
            header('Location: '.$redirection);
            exit(0);
		}
	}
	//on récupère les interfaces déjà testée
	$checked_interface=array();
	$services = Model_esia::getServices($dbconnection,$node->getId());
	foreach($services as $service)
	{
		if(preg_match('#'.$pl_name.'#',$service['check_plugin_name']))
		{
			if(preg_match('#-i\s+([0-9]*)#',$service['parameter'],$regs))
			{
				$checked_interface[] =$regs[1];
			}
		}
	}

	//$services = Model_esia::getServices($dbconnection,$node->getId());
	$inter_table_smarty=array();
	foreach ($interfaces as $inter)
	{
		if(!preg_match('#vlan#',$inter->ifDescr))
		{
			//on vérifie que le capteur n'est pas déjà testé
			$graph=0;
			$status='down';
			if($inter->ifOperStatus==1)
			{
				$status='up';
			}
			if(array_search($inter->ifIndex,$checked_interface)!==false)
			{
				$graph=1;
			}
			$descr_tmp = $inter->ifDescr;
			//Si description est vide, on prend le ifName. Si il est vide aussi, le ifindex sera pris pour le nom du service au moment de l'ajout
			if(empty($descr_tmp))
			{
				$inter_table_smarty[]=array('id'=>$inter->ifIndex,'name'=>$inter->ifName,'descr'=>$inter->ifDescr,'alias'=>$inter->ifAlias,'status'=>$status,'graph'=>$graph);
			}
			else
			{
				$inter_table_smarty[]=array('id'=>$inter->ifIndex,'name'=>$inter->ifDescr,'descr'=>$inter->ifDescr, 'status'=>$status,'graph'=>$graph);
			}
		}
	}
	$smarty->assign('interfaces', $inter_table_smarty);
	$smarty->assign('srvid', $node->getId());
}
elseif($_GET['action']=='shInfo' || $_GET['action']=='shConf' || $_GET['action']=='shInterface')
{
	try
	{
		//On crée l'objet USL
		$usl = new USL($node->getConfigurationTemplate());
		//on demande à l'usl de généré la commande d'information du sw
		if($_GET['action']=='shInfo')
		{
			$smarty->assign('l_sw_shrun_title', $lang['SW_CTRL_SW_VIEW_INFO']);
			$usl->getUSL()->command("show version");
		}
		elseif($_GET['action']=='shConf')
		{
			$smarty->assign('l_sw_shrun_title', $lang['SW_CTRL_SW_SH_RUN_TITLE']);
			$usl->getUSL()->command("show config",'');
		}
		else
		{
			echo$_GET['ifname'];
			if(isset($_GET['ifname']))
			{
				$smarty->assign('l_sw_shrun_title', $_GET['ifname']);
				$usl->getUSL()->command("show interface",$_GET['ifname']);
			}

		}
		$command = $usl->getGenerateConfiguration();
		//on upload la configuration
		$re = $node->uploadConfiguration($command);
		//on crée un tableau pour séparé les lignes
		$re = explode("\n",$re);
		$smarty->assign('sw_sh_info',$re);
	}
	catch(USLException $e)
	{
		$errors[]=array('id'=>'','name'=>'shRun','status'=>$lang['SW_CTRL_SW_NO_TEMPLATE']);
	}
	catch(SwitchUnsupportedManufacturerException $e)
	{
		$errors[]=array('id'=>'','name'=>'shRun','status'=>$lang['SW_CTRL_SW_MANUFACTURER_UN']);
	}
	catch(SwitchNoConfigurationTemplateException $e)
	{
		$errors[]=array('id'=>'','name'=>'shRun','status'=>$lang['SW_CTRL_SW_NO_TEMPLATE']);
	}
	catch(SwitchCommandNoPresentInTemplateException $e)
	{
		$errors[]=array('id'=>'','name'=>'shRun','status'=>$lang['SW_CTRL_SW_UNSUPORTED_FONCTION']);
	}
	catch(SwitchConnectionFailedException $e)
	{
		$errors[]=array('id'=>'','name'=>'shRun','status'=>$lang['ADM_SW_ADD_TELNET_FAILED']);
	}
}
else
{
	try
	{
		include_once $path.'/libs/logo_oid.hash.php';
		$smarty->assign('node_sysdescr',$node->getSysDescr());
		$smarty->assign('node_syscontact',$node->getSysContact());
		$smarty->assign('node_syslocation',$node->getSysLocation());
		$smarty->assign('node_sysname',$node->getSysName());
		$smarty->assign('node_uptime',$node->getUpTime());
		if(@get_class($node)!='RemoteSwitch')
		{
			try
			{
			//echo 'ici'.$node->getHTMLTemplate();
			$smarty->assign('sw_template',$node->getHTMLTemplate());
			$smarty->assign('sw_model',$node->setModelBySNMP() );
			$smarty->assign('sw_css',$node->getManufacturerCSS() );
			}
			catch(Exception $e)
			{

			}
		}
		$objectid = $node->getSysObjectId();
		$logo = IANA::getManufacturerLogo($objectid, $node->getSysDescr());
		$smarty->assign('manufacturer_name',$logo['name']);
		$smarty->assign('manufacturer_logo',$logo['logo']);
		//on récupère toutes les interfaces
		$interfaces = $node->getInterfacesMib('short');
		//print_r($interfaces);
		$services = Model_esia::getServices($dbconnection,$node->getId());
		$inter_table_smarty=array();

		foreach ($interfaces as $inter)
		{
			//echo $inter->ifDescr.'<br />';
				$idservice=-1;
				$status='down';
				if($inter->ifOperStatus==1)
				{
					$status='up';
				}
				foreach($services as $service)
				{
					if(preg_match('#CHECK_SNMP_SW_INTERFACE#',$service['name']) || preg_match('#GESA_SNMP_SW_INTERFACE#',$service['name']))
					{
						if(preg_match('#\-i\s+([0-9]*)#',$service['parameter'],$regs))
						{
							if($regs[1]==$inter->ifIndex)
							{
								$idservice = $service['id'];
							}
						}
					}
				}
				$speed=10;
				if($inter->ifSpeed!=0)
				{
					$speed = $inter->ifSpeed/1000 /1000;
				}
				$inter_table_smarty[]=array('id'=>$inter->ifIndex,'ifIndex'=>$inter->ifIndex,'name'=>$inter->ifDescr,'ifType'=>$inter->ifType ,'statut'=>$status,'serviceid'=>$idservice,'speed'=>$speed);

		}
		//on élimine les interfaces "non ethernet"
		$list_int = array();
		foreach($inter_table_smarty as $int)
		{
			if($int['ifType']==6 || $int['ifType']==117|| $int['ifType']==161)
			{
				$list_int[]=$int;
			}
		}
		$inter_table_smarty=$list_int;
		//resposition des interface selon un emplacement
		//
		//	eth1|eth3|eth5|eth7|eth9|eth11
		//  eth2|eth4|eth6|eth8|eth10|eth12
		$nbr_inter=count($inter_table_smarty);
		$i=0;
		$list_int = array();
		while($i<$nbr_inter)
		{
			$list_int[]=$inter_table_smarty[$i];
			$i=$i+2;
		}
		$i=1;
		while($i<$nbr_inter)
		{
			$list_int[]=$inter_table_smarty[$i];
			$i=$i+2;
		}
		unset($inter_table_smarty);

		$smarty->assign('sw_interfaces',$list_int);
	}
	catch(DeviceException $e)
	{
		//echo $e->getMessage();
		$errors[]=array('id'=>'','name'=>'','status'=>$lang['SW_SNMP_FAILED']);
	}
	catch(SNMPException $e)
	{
		//echo $e->getMessage();
		$errors[]=array('id'=>'','name'=>'','status'=>$lang['SW_SNMP_FAILED']);
	}
	//echo'<pre>'.print_r($interfaces,true).'</pre>';
}
$smarty->assign('sw_error',$errors);
//variable de langue
$smarty->assign('icn_informattion', $ICONS['information']);
$smarty->assign('icn_show_conf', $ICONS['show_log']);
$smarty->assign('l_id', $lang['SW_IF_INDEX']);
$smarty->assign('l_description', $lang['ADM_DESCRIPTION']);
$smarty->assign('l_name', $lang['SW_LIST_SW_NAME']);
$smarty->assign('l_status', $lang['SW_GEN_SW_TABLE_STATUS']);
$smarty->assign('l_speed', $lang['SW_IF_SPEED']);
$smarty->assign('l_inoctet', $lang['SW_IF_INOCTET']);
$smarty->assign('l_inerroroctet', $lang['SW_IF_INOCTETERROR']);
$smarty->assign('l_outoctet', $lang['SW_IF_OUTOCTET']);
$smarty->assign('l_outerroroctet', $lang['SW_IF_OUTOCTETERROR']);
$smarty->assign('l_alias', $lang['SW_IF_IALIAS']);
$smarty->assign('l_uptime_during', $lang['SW_UPTIME_DURING']);
$smarty->assign('l_packet', $lang['SW_PACKET']);
$smarty->display($template_path.'/sw_widget.html');
